/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.dto.shareGroupuser.ShareGroupUser;
import vip.xiaonuo.disk.mapper.ShareGroupUserMapper;
import vip.xiaonuo.disk.dto.shareGroupuser.ShareGroupAddParam;
import vip.xiaonuo.disk.dto.shareGroupuser.ShareGroupEditParam;
import vip.xiaonuo.disk.dto.shareGroupuser.ShareGroupIdParam;
import vip.xiaonuo.disk.dto.shareGroupuser.ShareGroupUserPageParam;
import vip.xiaonuo.disk.service.ShareGroupUserService;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 资源共享-群组人员关联表Service接口实现类
 *
 * @author honorfire
 * @date  2025/06/18 14:16
 **/
@Service
public class ShareGroupUserServiceImpl extends ServiceImpl<ShareGroupUserMapper, ShareGroupUser> implements ShareGroupUserService {

    @Resource
    private ShareGroupUserMapper shareGroupUserMapper;


    @Override
    public Page<ShareGroupUser> page(ShareGroupUserPageParam shareGroupUserPageParam) {
        QueryWrapper<ShareGroupUser> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(shareGroupUserPageParam.getSortField(), shareGroupUserPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(shareGroupUserPageParam.getSortOrder());
            queryWrapper.orderBy(true, shareGroupUserPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(shareGroupUserPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(ShareGroupUser::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(ShareGroupAddParam shareGroupAddParam) {
        ShareGroupUser shareGroupUser = BeanUtil.toBean(shareGroupAddParam, ShareGroupUser.class);
        this.save(shareGroupUser);
    }

    /**
     * 添加资源共享-群组人员关联表
     *
     * @author honorfire
     * @date  2025/06/18 14:16
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public ShareGroupUser addone(ShareGroupUser shareGroupUser)
    {
        this.save(shareGroupUser);
        return shareGroupUser;
    }

    /**
     * 添加资源共享-群组人员关联表-批量
     *
     * @author honorfire
     * @date  2025/06/18 14:16
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void addBatch(List<ShareGroupUser> shareGroupUserList)
    {
        this.saveBatch(shareGroupUserList);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(ShareGroupEditParam shareGroupEditParam) {
        ShareGroupUser shareGroupUser = this.queryEntity(shareGroupEditParam.getId());
        BeanUtil.copyProperties(shareGroupEditParam, shareGroupUser);
        this.updateById(shareGroupUser);
    }

    /**
     * 添加资源共享-群组人员关联表
     *
     * @author honorfire
     * @date  2025/06/18 14:16
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public ShareGroupUser editone(ShareGroupUser shareGroupUser)
    {
        this.updateById(shareGroupUser);
        return shareGroupUser;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<ShareGroupIdParam> shareGroupIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(shareGroupIdParamList, ShareGroupIdParam::getGroupId));
    }

    /**
     * 删除资源共享-群组人员关联表
     *
     * @author honorfire
     * @date  2025/06/18 14:16
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void deleteByIds(List<String> deleteIdList)
    {
        this.removeByIds(deleteIdList);
    }

    @Override
    public ShareGroupUser detail(ShareGroupIdParam shareGroupIdParam) {
        return this.queryEntity(shareGroupIdParam.getGroupId());
    }

    @Override
    public ShareGroupUser queryEntity(String id) {
        ShareGroupUser shareGroupUser = this.getById(id);
        if(ObjectUtil.isEmpty(shareGroupUser)) {
            throw new CommonException("资源共享-群组人员关联表不存在，id值为：{}", id);
        }
        return shareGroupUser;
    }

    /**
     * 群组人员关联表-查询列表
     *
     * @author honorfire
     * @date  2025/06/18 14:16
     **/
    @Override
    public List<Map<String, Object>> queryGroupUserList(Map param)
    {
        return shareGroupUserMapper.queryGroupUserList(param);
    }

}
